# cargo doc

## NAME

cargo-doc - Build a package's documentation

## SYNOPSIS

`cargo doc [OPTIONS]`

## DESCRIPTION

Build the documentation for the local package and all dependencies. The output is placed in `target/doc` in rustdoc’s usual format.

## OPTIONS

### Documentation Options

--open

  Open the docs in a browser after building them.

--no-deps

  Do not build documentation for dependencies.

--document-private-items

  Include non-public items in the documentation.

### Package Selection

By default, when no package selection options are given, the packages selected depend on the current working directory. In the root of a virtual workspace, all workspace members are selected (`--all` is implied). Otherwise, only the package in the current directory will be selected. The default packages may be overridden with the `workspace.default-members` key in the root `Cargo.toml` manifest.

-p SPEC…​
--package SPEC…​

  Document only the specified packages. See cargo-pkgid(1) for the SPEC format. This flag may be specified multiple times.

--all

  Document all members in the workspace.

--exclude SPEC…​

  Exclude the specified packages. Must be used in conjunction with the `--all` flag. This flag may be specified multiple times.

### Target Selection

When no target selection options are given, `cargo doc` will document all binary and library targets of the selected package. The binary will be skipped if its name is the same as the lib target. Binaries are skipped if they have `required-features` that are missing.

The default behavior can be changed by setting `doc = false` for the target in the manifest settings. Using target selection options will ignore the `doc` flag and will always document the given target.

--lib

  Document the package’s library.

--bin NAME…​

  Document the specified binary. This flag may be specified multiple times.

--bins

  Document all binary targets.

### Feature Selection

When no feature options are given, the `default` feature is activated for every selected package.

--features FEATURES

  Space or comma separated list of features to activate. These features only apply to the current directory’s package. Features of direct dependencies may be enabled with `<dep-name>/<feature-name>` syntax.

--all-features

  Activate all available features of all selected packages.

--no-default-features

  Do not activate the `default` feature of the current directory’s package.

### Compilation Options

--target TRIPLE

  Document for the given architecture. The default is the host architecture. The general format of the triple is `<arch><sub>-<vendor>-<sys>-<abi>`. Run `rustc --print target-list` for a list of supported targets.

  This may also be specified with the `build.target` config value.

--release

  Document optimized artifacts with the `release` profile. See the PROFILES section for details on how this affects profile selection.

### Output Options

--target-dir DIRECTORY

  Directory for all generated artifacts and intermediate files. May also be specified with the `CARGO_TARGET_DIR` environment variable, or the `build.target-dir` config value. Defaults to `target` in the root of the workspace.

### Display Options

-v
--verbose

  Use verbose output. May be specified twice for "very verbose" output which includes extra output such as dependency warnings and build script output. May also be specified with the `term.verbose` config value.

-q
--quiet

  No output printed to stdout.

--color WHEN

  Control when colored output is used. Valid values:

  - `auto` (default): Automatically detect if color support is available on the terminal.

  - `always`: Always display colors.

  - `never`: Never display colors.

  May also be specified with the `term.color` config value.

--message-format FMT

  The output format for diagnostic messages. Valid values:

  - `human` (default): Display in a human-readable text format.

  - `json`: Emit JSON messages to stdout.

  - `short`: Emit shorter, human-readable text messages.

### Manifest Options

--manifest-path PATH

  Path to the `Cargo.toml` file. By default, Cargo searches in the current directory or any parent directory for the `Cargo.toml` file.

--frozen
--locked

  Either of these flags requires that the `Cargo.lock` file is up-to-date. If the lock file is missing, or it needs to be updated, Cargo will exit with an error. The `--frozen` flag also prevents Cargo from attempting to access the network to determine if it is out-of-date.

  These may be used in environments where you want to assert that the `Cargo.lock` file is up-to-date (such as a CI build) or want to avoid network access.

### Common Options

-h
--help

  Prints help information.

-Z FLAG…​

  Unstable (nightly-only) flags to Cargo. Run `cargo -Z help` for details.

### Miscellaneous Options

-j N
--jobs N

  Number of parallel jobs to run. May also be specified with the `build.jobs` config value. Defaults to the number of CPUs.

## PROFILES

Profiles may be used to configure compiler options such as optimization levels and debug settings. See the reference for more details.

Profile selection depends on the target and crate being built. By default the `dev` or `test` profiles are used. If the `--release` flag is given, then the `release` or `bench` profiles are used.

Target | Default Profile | `--release` Profile
--- | --- | ---
lib, bin, example | `dev` | `release`
test, bench, or any target in "test" or "bench" mode | `test` | `bench`

Dependencies use the `dev`/`release` profiles.

## ENVIRONMENT

See the reference for details on environment variables that Cargo reads.

## Exit Status

0

  Cargo succeeded.

101

  Cargo failed to complete.

## EXAMPLES

1. Build the local package documentation and its dependencies and output to `target/doc`.

       cargo doc

## SEE ALSO

cargo(1), cargo-rustdoc(1), rustdoc(1)